package cn.ibizlab.assetmanagement.core.asset.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.asset.domain.EAMAssetPartsGroup;
import cn.ibizlab.assetmanagement.core.asset.filter.EAMAssetPartsGroupSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMAssetPartsGroup] 服务对象接口
 */
public interface IEAMAssetPartsGroupService extends IService<EAMAssetPartsGroup>{

    boolean create(EAMAssetPartsGroup et) ;
    void createBatch(List<EAMAssetPartsGroup> list) ;
    boolean update(EAMAssetPartsGroup et) ;
    void updateBatch(List<EAMAssetPartsGroup> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMAssetPartsGroup get(String key) ;
    EAMAssetPartsGroup getDraft(EAMAssetPartsGroup et) ;
    boolean checkKey(EAMAssetPartsGroup et) ;
    boolean save(EAMAssetPartsGroup et) ;
    void saveBatch(List<EAMAssetPartsGroup> list) ;
    Page<EAMAssetPartsGroup> searchDefault(EAMAssetPartsGroupSearchContext context) ;
    List<EAMAssetPartsGroup> selectByEamassettypeid(String eamassettypeid) ;
    void removeByEamassettypeid(String eamassettypeid) ;
    List<EAMAssetPartsGroup> selectByEamsparepartsgroupid(String eamsparepartsgroupid) ;
    void removeByEamsparepartsgroupid(String eamsparepartsgroupid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMAssetPartsGroup> getEamassetpartsgroupByIds(List<String> ids) ;
    List<EAMAssetPartsGroup> getEamassetpartsgroupByEntities(List<EAMAssetPartsGroup> entities) ;
}


